--ReaScript Name: ASM [SCRIPT] ENV Set new selected automation items points value
--Author: AmelianceSkyMusic 2018

script_title = "ASM [SCRIPT] ENV Set new selected automation items points value"

function Msg(param) reaper.ShowConsoleMsg(tostring(param).."\n") end
reaper.ShowConsoleMsg("")

--function myRound(num, idp)
--  local mult = 10^(idp or 0)
--  return math.floor(num * mult + 0.5) / mult
--end

function myRound(num, idp)--convert numbers
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

reaper.Undo_BeginBlock()
reaper.PreventUIRefresh(1)

------------------selected envelop userdata------------------
envelop_sel = reaper.GetSelectedEnvelope(0)
if not envelop_sel then reaper.defer(function() end) return end
-------------------------------------------------------------

------------------how many items in envelope------------------
count_eItems = reaper.CountAutomationItems(envelop_sel)
if count_eItems < 1 then reaper.defer(function() end) return end
--Msg('count_eItems: '..count_eItems)
-------------------------------------------------------------

count_sel_ePoint_Ex = 0
pValue_low_prev_Ex = ''
pValue_low = ''

for sel_aItems = 0, count_eItems - 1 do

  -----------------how many points in envelope---------------
  count_ePoints = reaper.CountEnvelopePointsEx(envelop_sel, sel_aItems)
  if count_ePoints < 1 then reaper.defer(function() end) return end
  -------------------------------------------------------------

  ------------------how many selected points------------------
  --------------------get lower pointvalue--------------------
  count_sel_ePoint = 0
  
  for p = 0, count_ePoints - 1 do
  
      p1, ePoint_time, get_pValue_low, p4, p5, ePoint_sel = reaper.GetEnvelopePointEx(envelop_sel, sel_aItems, p)
      
      if ePoint_sel then
      
        if pValue_low == '' then
        
          pValue_low = get_pValue_low
          
        end
      
        if get_pValue_low < pValue_low then
        
          pValue_low = get_pValue_low
          
        end
        
        count_sel_ePoint = count_sel_ePoint + 1         
        
        --Msg('pValue_low'..pValue_low)
        
      end
      
  end
  
  
  count_sel_ePoint_Ex = count_sel_ePoint_Ex + count_sel_ePoint
  
  --Msg('count_sel_ePoint_Ex'..count_sel_ePoint_Ex)
  
  
  
  -------------------------------------------------------------

end


if count_sel_ePoint_Ex < 1 then reaper.defer(function() end) return end

pValue_low = myRound(pValue_low, 5)
  
retval, new_user_value = reaper.GetUserInputs("Set new point value", 1, "Value:", pValue_low) --Get users new value

new_user_value = myRound(new_user_value, 5)
  

for sel_aItems = 0, count_eItems - 1 do

  for i = 0, count_ePoints - 1 do
  
      p1, ePoint_time, pValue, p4, p5, ePoint_sel = reaper.GetEnvelopePointEx(envelop_sel, sel_aItems, i)
      -- Msg(p1) -- retval
      --Msg("ePoint_time "..ePoint_time) --time
      --Msg(pValue) --point value, basic 1.0 -/+
      -- Msg(p4) --shape
      -- Msg(p5) --tension
      --Msg(ePoint_sel) --false or true
      pValue = myRound(pValue, 5)
      
      dif_new_value = pValue_low - new_user_value
      
      new_value = pValue - dif_new_value
  
      ePoint_num = reaper.GetEnvelopePointByTimeEx(envelop_sel, sel_aItems, ePoint_time)
  
      if ePoint_sel then
        
        new_value = myRound(new_value, 5)
        
        reaper.SetEnvelopePointEx(envelop_sel, sel_aItems, i, ePoint_time_last, new_value, nil, nil, nil, 1) --Set new value
          
      end
  
  end
--reaper.UpdateArrange()
end
      
reaper.UpdateArrange()
reaper.PreventUIRefresh(-1)
reaper.Undo_EndBlock(script_title, 0)
