--ReaScript Name: ASM [SCRIPT] ENV Set new selected points value
--Author: AmelianceSkyMusic 2018

script_title = "ASM [SCRIPT] ENV Set new selected points value"

function Msg(param) reaper.ShowConsoleMsg(tostring(param).."\n") end
reaper.ShowConsoleMsg("")

--function myRound(num, idp)
--  local mult = 10^(idp or 0)
--  return math.floor(num * mult + 0.5) / mult
--end

function myRound(num, idp)--convert numbers
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

reaper.Undo_BeginBlock()
reaper.PreventUIRefresh(1)

------------------selected envelop userdata------------------
envelop_sel = reaper.GetSelectedEnvelope(0)
if not envelop_sel then reaper.defer(function() end) return end
-------------------------------------------------------------

-----------------how many points in envelope---------------
count_ePoints = reaper.CountEnvelopePoints(envelop_sel)
if count_ePoints < 1 then reaper.defer(function() end) return end
-------------------------------------------------------------

------------------how many selected points------------------
--------------------get lower pointvalue--------------------
count_sel_ePoint = 0
pValue_low = ''

for p = 0, count_ePoints - 1 do

    p1, ePoint_time, get_pValue_low, p4, p5, ePoint_sel = reaper.GetEnvelopePoint(envelop_sel, p)
    
    if ePoint_sel then
      
      if pValue_low == '' then
        
        pValue_low = get_pValue_low
          
      end
      
      if get_pValue_low < pValue_low then
        
        pValue_low = get_pValue_low
          
      end
      
      
      count_sel_ePoint = count_sel_ePoint + 1 
      
    end
    
    
end
-------------------------------------------------------------

pValue_low = myRound(pValue_low, 5)
 
retval, new_user_value = reaper.GetUserInputs("Set new point value", 1, "Value:", pValue_low) --Get users new value

new_user_value = myRound(new_user_value, 5)


for i = 0, count_ePoints - 1 do

    p1, ePoint_time, pValue, p4, p5, ePoint_sel = reaper.GetEnvelopePoint(envelop_sel, i)
    -- Msg(p1) -- retval
    --Msg("ePoint_time "..ePoint_time) --time
    --Msg(pValue) --point value, basic 1.0 -/+
    -- Msg(p4) --shape
    -- Msg(p5) --tension
    --Msg(ePoint_sel) --false or true
    
    pValue = myRound(pValue, 5)
    
    dif_new_value = pValue_low - new_user_value
    
    new_value = pValue - dif_new_value

    ePoint_num = reaper.GetEnvelopePointByTime(envelop_sel, ePoint_time)

    if ePoint_sel then
    
      reaper.SetEnvelopePoint(envelop_sel, i, ePoint_time_last, new_value, nil, nil, nil, 1) --Set new value
        
    end

end
      
reaper.UpdateArrange()
reaper.PreventUIRefresh(-1)
reaper.Undo_EndBlock(script_title, 0)
